//Private
//var _events = [];
//var exporterDvdStl = require("./ExporterDvdStl.js");

function Exporter(filepath, data) {
	console.log("ExporterDvdStl: Exporter: called with filepath=["+filepath+"]");
	var fs = require('fs');
	var wstream = fs.createWriteStream(filepath, {encoding: "utf8"});
	writeFileSTL(wstream,data)
	wstream.end();
}

function writeFileSTL(strm, o){
	//https://web.archive.org/web/20091028173024/http://geocities.com/McPoodle43/DVDMaestro/stl_format.html
	//English subtitles
	//$FontName           = Arial
	//$FontSize           = 36
	//$HorzAlign          = Center
	//$VertAlign          = Bottom
	//$XOffset            = 0
	//$YOffset            = 0
	//$ColorIndex1        = 0
	//$ColorIndex2        = 2
	//$ColorIndex3        = 8
	//$ColorIndex4        = 3
	//$Contrast1          = 15
	//$Contrast2          = 0
	//$Contrast3          = 15
	//$Contrast4          = 0
	//$ForceDisplay       = FALSE
	//$FadeIn             = 3
	//$FadeOut            = 7
	//$TapeOffset         = FALSE

	//00:00:00:00 , 00:00:15:10,Start of video.
	//00:00:15:11,00:00:17:12,Puts down toy.
	//00:00:17:13,00:00:25:18,Picks up toy again|and then lies down.


	//header
	strm.write("//UNCOMMENT HEADER LINES BELOW (IF YOUR SYSTEM NEEDS THEM) BY DELETING THE starting \"//\"\n");
	strm.write("//$FontName\t = Arial\n");
	strm.write("//$FontSize\t = 36\n");
	strm.write("//$HorzAlign\t = Center\n");
	strm.write("//$VertAlign\t = Bottom\n");
	strm.write("//$XOffset\t = 0\n");
	strm.write("//$YOffset\t = 0\n");
	strm.write("//$ColorIndex1\t = 0\n");
	strm.write("//$ColorIndex2\t = 2\n");
	strm.write("//$ColorIndex3\t = 8\n");
	strm.write("//$ColorIndex4\t = 3\n");
	strm.write("//$Contrast1\t = 15\n");
	strm.write("//$Contrast2\t = 0\n");
	strm.write("//$Contrast3\t = 15\n");
	strm.write("//$Contrast4\t = 0\n");
	strm.write("//$ForceDisplay\t = FALSE\n");
	strm.write("//$FadeIn\t = 3\n");
	strm.write("//$FadeOut\t = 7\n");
	strm.write("//$TapeOffset\t = FALSE\n");
	strm.write("\n");	//blank line
	
	var sfoo = "";
	for( var i=0; i<o.events.length; i++ ){
		//console.log(JSON.stringify(o.events[i],null,5));
		thetext = eventToSTL(o.events[i]);
		strm.write(o.events[i].intime.toTimecodeSMPTE() + ' , ' + o.events[i].outtime.toTimecodeSMPTE() + ' , ' + thetext +'\n');
	}
	strm.write('\n');
}//writeFileSRT
function eventToSTL(e){
	var sfoo="", ret="", tr={}, bgottext = false;
	//log.debug("eventToVTT: textRuns=["+JSON.stringify(e.textRuns, null, 2)+"]");
	for( var i=0; i<e.textRuns.length; i++ ){
		//if( i==0 ) sfoo = "";
		tr=e.textRuns[i];
		sfoo = tr.text;
		
		if( sfoo.trim().length > 0 )
			bgottext = true;
		//log.debug("eventToVTT: tr.id=["+tr.id+"] bgotext=["+bgottext+"]");
		
		if( tr.linebreak ){
			if( bgottext ){	//linebreak and already found text
				//log.debug("eventToVTT: tr.id=["+tr.id+"] linebreak=true, bgottext=true");
				ret += " | ";
				bgottext = false;
				continue;
			} else {		//linebreak and no text yet
				//log.debug("eventToVTT: tr.id=["+tr.id+"] linebreak=true, bgottext=false");
				continue;
			}
		} else {
		}
		
		//log.debug("eventToSRT: run sfoo=["+sfoo+"] len=["+sfoo.length+"] endval=["+sfoo.charCodeAt(1)+"]");
		//if( sfoo.length==0 ) sfoo = " ";//"\u200B";//use zero-width space instead of a space// =" ";
		if( i==e.textRuns.length-1 ) sfoo = sfoo.replace(/\s+$/, ''); //sfoo = sfoo.trim(); //trim the last space
		
		ret += sfoo;
		//log.debug("eventToSRT: normal ret now=["+ret+"]");
		
	}//textRuns
	
	//log.debug("eventToSRT: finally return ret=["+ret+"] len=["+ret.length+"]");
	return ret;

}//eventToSRT


//Public
module.exports = Exporter;
