//////////////////////////////
// Player dispatcher class for CADET
//////////////////////////////
var PDEditor;
class PlayerDispatch {
	static setEditor(editor){
		PDEditor = editor;
		PlayerDispatch.editor = editor;
	}
	static getEditor(){
		return PlayerDispatch.editor;
	}
	
	static showPlayer(type) {
		var ret = null;
		switch(mediaLocationType){
			case MEDIA_LOCATION_LOCAL:
				//unshow vimeo player
				$("#cadetplayerRemote").css("display","none");			//hide remote div
				$("#remoteSubstitute").css("display","none");			//hide VIMEO player
				
				//unshow youtube player
				$("#cadetplayerRemote").css("display","none");			//hide remote div
				$("#remoteSubstituteYT").css("display","none");			//hide VIMEO player
				
				//show local player
				$("#cadetplayerLocal").css("display","");	//show local player
							
				break;
				
			case MEDIA_LOCATION_YT:
				//unshow local player
				$("#cadetvideo")[0].src=""; 
				var trk=$("#cadetvideo > track")[0];
				trk.src="";
				$("#cadetplayerLocal").css("display","none");	//hide local player
			
				//unshow vimeo player
				$("#cadetplayerRemote").css("display","none");			//hide remote div
				$("#remoteSubstitute").css("display","none");			//hide VIMEO player
				
				//show youtube player
				$("#cadetplayerRemote").css("display","");			//show remote div
				$("#remoteSubstituteYT").css("display","");			//show YOUTUBE player
				
				break;
			case MEDIA_LOCATION_VIMEO:
				//unshow local player
				$("#cadetvideo")[0].src=""; 
				var trk=$("#cadetvideo > track")[0];
				trk.src="";
				$("#cadetplayerLocal").css("display","none");	//hide local player
				
				//hide youtube player
				$("#cadetplayerRemote").css("display","none");			//hide remote div
				$("#remoteSubstituteYT").css("display","none");			//hide YOUTUBE player
			
				//unshow vimeo player
				$("#cadetplayerRemote").css("display","");			//show remote div
				$("#remoteSubstitute").css("display","");			//show VIMEO player
				
				break;
			default:
				ret = null;
				break;
		}
	}//showPlayer

	static loadRemoteVideo(vidid) {
		var ret = null;
		switch(mediaLocationType){
			case MEDIA_LOCATION_YT:
				ret = YTplayer ? YTplayer.loadVideo(vidid) : null;
				break;
			case MEDIA_LOCATION_VIMEO:
				ret = VimeoPlayer ? VimeoPlayer.loadVideo(vidid) : null;
				break;
			default:
				ret = null;
				break;
		}
		this.editor.justFocusCaptionCell(0);
	}//loadRemoteVideo
	static unloadRemoteVideo() {
		var ret = null;
		switch(mediaLocationType){
			case MEDIA_LOCATION_YT:
				YTplayer.unloadVideo();
				break;
			case MEDIA_LOCATION_VIMEO:
				VimeoPlayer.unloadVideo();
				break;
			default:
				ret = null;
				break;
		}
	}//unloadRemoteVideo
	
	
	static playerGetTime() {
		var ret = 0.0;
		switch(mediaLocationType){
			case MEDIA_LOCATION_LOCAL:
				ret = this.editor.getMediaTime(); //$("video")[0].currentTime;
				break;
			case MEDIA_LOCATION_YT:
				ret = YTplayer ? YTplayer.getTime() : 0.0;
				break;
			case MEDIA_LOCATION_VIMEO:
				ret = VimeoPlayer ? VimeoPlayer.getTime() : 0.0;
				break;
			default:
				ret = 0.0
				break;
		}
		return ret;
	}//playerGetTime
	
	static displayCaptions(b) {
		var ret = b;
		switch(mediaLocationType){
			case MEDIA_LOCATION_LOCAL:
				var v = document.getElementById("cadetvideo")
				v.textTracks[0].mode = b ? "showing" : "hidden";  // "showing"/"hidden" 
				break;
			case MEDIA_LOCATION_YT:
				ccDisplay.enableCC(b);
				break;
			case MEDIA_LOCATION_VIMEO:
				ccDisplay.enableCC(b);
				break;
			default:
				break;
		}
		return ret;
	}
	
	static setPlayerSpeed(x){
		switch(mediaLocationType){
			case MEDIA_LOCATION_LOCAL:
				this.editor.setPlayerSpeed(x);
				break;
			case MEDIA_LOCATION_YT:
				YTplayer.setPlayerSpeed(x);
				break;
			case MEDIA_LOCATION_VIMEO:
				VimeoPlayer.setPlayerSpeed(x);
				break;
			default:
				break;
		}
	}
	
	static playerIsPaused(){
		switch(mediaLocationType){
			case MEDIA_LOCATION_LOCAL:
				return this.editor.playerIsPaused();
				break;
			case MEDIA_LOCATION_YT:
				return YTplayer.isPaused();
				break;
			case MEDIA_LOCATION_VIMEO:
				return VimeoPlayer.isPaused(); //VimeoPlayer.isPaused();  //FIGURE OUT THE PROMISE THING!!
				break;
			default:
				break;
		}
		return false;
	}

	static playerPlay(){
		switch(mediaLocationType){
			case MEDIA_LOCATION_VIMEO:
				VimeoPlayer.play();
				break;
			default:
				break;
		}
		return;
	}
	static playerPause(){
		switch(mediaLocationType){
			case MEDIA_LOCATION_VIMEO:
				VimeoPlayer.pause();
				break;
			default:
				break;
		}
		return;
	}
	static playerPlayPause(editor) {
		switch(mediaLocationType){
			case MEDIA_LOCATION_LOCAL:
				this.editor.playPauseMedia();
				break;
			case MEDIA_LOCATION_YT:
				YTplayer.playPauseMedia();
				break;
			case MEDIA_LOCATION_VIMEO:
				VimeoPlayer.playPauseMedia();
				break;
			default:
				break;
		}
		return;
	}
	static playerPlayPauseSpecial(editor) {
		switch(mediaLocationType){
			case MEDIA_LOCATION_LOCAL:
				this.editor.playPauseSpecial();
				break;
			case MEDIA_LOCATION_YT:
				YTplayer.playPauseMediaSpecial();
				break;
			case MEDIA_LOCATION_VIMEO:
				VimeoPlayer.playPauseMediaSpecial();
				break;
			default:
				break;
		}
		return;
	}
	static cueMedia(s) {
		switch(mediaLocationType){
			case MEDIA_LOCATION_LOCAL:
				this.editor.cueMedia(s);
				break;
			case MEDIA_LOCATION_YT:
				YTplayer.cueMedia(s);
				break;
			case MEDIA_LOCATION_VIMEO:
				VimeoPlayer.cueMedia(s);
				break;
			default:
				break;
		}
		return;
	}

	static requestFullScreen() {
		launchIntoFullscreen(document.getElementById("cadetplayerwrapper"));
		return;
		switch(mediaLocationType){
			case MEDIA_LOCATION_LOCAL:
				launchIntoFullscreen(document.getElementById("cadetvideo"));
				break;
				
			case MEDIA_LOCATION_YT:
				launchIntoFullscreen(document.getElementById("cadetplayerRemote"));
				break;
				
			case MEDIA_LOCATION_VIMEO:
				launchIntoFullscreen(document.getElementById("cadetplayerRemote"));
				break;
				
			default:
				break;
		}
		return;
	}
	
	static resizePlayerObject(w,h){
	
		switch(mediaLocationType){
			case MEDIA_LOCATION_LOCAL:
				//debug("PLAYER0: resizePlayerObject local");
				if( w===undefined ){
					//debug("PLAYER0: resizePlayerObject local 100%");
					$("#cadetvideo").css({"top":"0px", "left":"0px", "width":"100%", "height":"100%"});
				} else {
					//debug("PLAYER0: resizePlayerObject local w=["+w+"] h=["+h+"]");
					$("#cadetvideo").css({"top":"0px", "left":"0px", "height":h.toString()+"px", "width":w.toString()+"px"});
				}
				break;
			case MEDIA_LOCATION_YT:
				//debug("PLAYER0: resizePlayerObject YT");
				var isFullScreen = document.fullScreen || document.mozFullScreen || document.webkitIsFullScreen || (document.msFullscreenElement != null);
				if( isFullScreen ){    //fullscreen size
					$("#cadetplayerRemote").css({"top":"0px", "left":"0px", "width":"100%", "height":"100%", "position":"absolute"});
					if( YTplayer.player )
						YTplayer.player.setSize(1920,1024);	
				} else {
					$("#cadetplayerRemote").css({"top":"0px", "left":"0px", "position":"relative"});
					if( YTplayer.player )
						YTplayer.player.setSize(oldOuterWidth,oldOuterHeight);	
				}
					break;
			case MEDIA_LOCATION_VIMEO:
				//debug("PLAYER0: resizePlayerObject VIMEO");
				var isFullScreen = document.fullScreen || document.mozFullScreen || document.webkitIsFullScreen || (document.msFullscreenElement != null);
				if( isFullScreen ){    //fullscreen size
					$("#cadetplayerRemote").css({"top":"0px", "left":"0px", "width":"100%", "height":"100%", "position":""});
					if( VimeoPlayer.player ){
						//VimeoPlayer.player.setSize(1920,1024);
						//$("#remoteSubstitute > iframe").css({"height":"100%"});
						var when = PlayerDispatch.playerGetTime();
						VimeoPlayer.createPlayer(mediaUrl,$(document).width(),$(document).height(),when);
						if( !PlayerDispatch.playerIsPaused() ){ //get current playhead and keep playing from there
							PlayerDispatch.playerPlayPause();
						}
						PlayerDispatch.cueMedia(when);
					}
				} else {
					//$("#cadetplayerRemote").css({"top":"0px", "left":"0px", "position":"relative"});
					if( VimeoPlayer.player ){
						//VimeoPlayer.player.setSize(oldOuterWidth,oldOuterHeight);
						var when = PlayerDispatch.playerGetTime();
						var wasPaused = PlayerDispatch.playerIsPaused();
						VimeoPlayer.createPlayer(mediaUrl,oldOuterWidth,oldOuterHeight);
						if( !wasPaused ){ //get current playhead and keep playing from there
							PlayerDispatch.cueMedia(when);
							PlayerDispatch.playerPlay();
						} else {
							PlayerDispatch.cueMedia(when);
							//VimeoPlayer.player.play();
							//VimeoPlayer.player.pause();
						}
					}
				}
		}
		return
	}
	/**/
	static renderCurrentCaption(){
		//debug("PlayerDispatch: renderCurrentCaption");
		this.editor.renderIthCaption(); //leave out the parameter to get current caption
	}//renderCurrentCaption
	
	static renderIthCaption(i){
		//debug("PlayerDispatch: renderIthCaption");
		this.editor.renderIthCaption(i);
	}//renderIthCaption
	
	static setUItime(n){
		var value = n;
		var svalue = (typeof value !== 'undefined')?value.toTimecode():"";
		$("#mediatime")[0].value = svalue;
	}
	
	static dragResizePlayer(w,h){
		switch(mediaLocationType){
			case MEDIA_LOCATION_LOCAL:
				var ifoo = $("#localProjectFile").height() + $("#localMediaFile").height() + $("#playSpeedDiv").height() + $("#cadetvideo").height()+ $("#resizerplayer").height() + 9;
				$("#cadetplayer").css('height', ifoo +"px");
				break;
				
			case MEDIA_LOCATION_YT:
				YTplayer.resizePlayer(w,h);
				break;
				
			case MEDIA_LOCATION_VIMEO:
				$("#cadetplayerRemote").css({"top":"0px", "left":"0px", "width":"100%", "height":"100%", "position":""});
				$("#remoteSubstitute").css({"width":w+"px", "height":h+"px"})
				if( VimeoPlayer.player ){
					VimeoPlayer.createPlayer(mediaUrl,w,h);
				}
				break;
				
			default:
				break;
		}
		PlayerDispatch.editor.focusCurrentRowCaptionCell();
		return;
	}//dragResizePlayer
	
	static mediaJump(bhow, inc){
		switch(mediaLocationType){
			case MEDIA_LOCATION_LOCAL:
				this.editor.mediaJump(bhow, inc);
				break;
				
			case MEDIA_LOCATION_YT:
				if( YTplayer.player )
					YTplayer.mediaJump(bhow, inc);
				break;
				
			case MEDIA_LOCATION_VIMEO:
				if( VimeoPlayer.player )
					VimeoPlayer.mediaJump(bhow, inc);
				break;
				
			default:
				break;
		}
		return;
	}//mediaJump

}//PlayerDispatch class

